#!/usr/bin/python

import sys
import numpy as np

# Retrieve command line args
# LOG_EXEC LOG_RESULT 

# Result File:
# _QGT_, _QPT_, _RET_, _TQS_, _TRS_, _PPT_
# _QGT_ = Query Generation Time
# _QPT_ = Query Processing Time
# _RET_ = Response Extraction Time
# _TQS_ = Total Query Size
# _TRS_ = Total REsponse Size
# _PPT_ = Database Preprocessing Time (one time cost)

LOG_EXEC = str(sys.argv[1])
K = int(sys.argv[2])
LOG_INTERMEDIATE_RESULT = str(sys.argv[3])
LOG_RESULT = str(sys.argv[4])

intermediate_file = open(LOG_INTERMEDIATE_RESULT, 'w')
result_file = open(LOG_RESULT, 'a')

QGT_vec = []
QPT_vec = []
QPT_QET_vec = []
QET_vec = []
RET_vec = []


with open(LOG_EXEC, 'r') as exec_log:
    for line in exec_log:
    	words = line.split(':')
    	if(words[0]=='_QGT_'):
            line = line.strip()
            words = line.split(' ')
            QGT = float(words[-2])
            QGT_vec.append(QGT)
            		
    	if(words[0]=='_QPT_'):
            line = line.strip()
            words = line.split(' ')
            QPT = float(words[-2])
            QPT_QET_vec.append(QPT)      

    	if(words[0]=='_QET_'):
            line = line.strip()
            words = line.split(' ')
            QET = float(words[-2])
            QET_vec.append(QET)      

    	if(words[0]=='_RET_'):
            line = line.strip()
            words = line.split(' ')
            RET = float(words[-2])
            # Adjusting reply extraction time by K
            RET = RET * K
            RET_vec.append(RET)

    	if(words[0]=='_TQS_'):
            line = line.strip()
            words = line.split(' ')
            TQS = int(words[-2])

    	if(words[0]=='_TRS_'):
            line = line.strip()
            words = line.split(' ')
            TRS = int(words[-2])
            TRS = TRS * K

    	if(words[0]=='_PPT_'):
            line = line.strip()
            words = line.split(' ')
            PPT = float(words[-2])

            outline = str(QGT)+','+str(QPT)+','+str(RET)+','+str(TQS)+','+str(TRS)+','+str(PPT)+'\n'
            intermediate_file.write(outline)


#Write the aggregates and errors to result file
QGT_avg = np.average(QGT_vec)
QGT_std = np.std(QGT_vec)

QPT_QET_avg = np.average(QPT_QET_vec)
QPT_QET_std = np.std(QPT_QET_vec)

QET_avg = np.average(QET_vec)
QET_std = np.std(QET_vec)


QPT_avg = QPT_QET_avg - QET_avg
# Adjusting reply extraction time by K
QPT_avg = QPT_avg * K
QPT_std = QPT_QET_std - QET_std

RET_avg = np.average(RET_vec)
RET_std = np.std(RET_vec)

result_file_line = str(round(QGT_avg,4))+','+str(round(QGT_std,4))+','+str(round(QPT_avg,4))+','+str(round(QPT_std,4))+','+str(round(RET_avg, 4))+','+str(round(RET_std,4))+','+str(TQS)+','+str(TRS)+','+str(round(PPT, 4))+'\n'
print(result_file_line)
result_file.write(result_file_line)

intermediate_file.close()
result_file.close()

